<template>
  <div class="artist-detail-section" :class="{ mobile: isMobileGlobal() }">
    <div style="position: relative" class="section-header">
      <img :src="artistInfo.img_thumb || artistInfo.img_banner" style="width: 100%; height: 120%;" />
      <div class="background-opacity"></div>
      <div class="header-artists">
        <div class="group-info">
          <img :src="artistInfo.img_thumb || artistInfo.img_banner" class="artist-avatar" v-if="isMobileGlobal()" />
          <h1 class="artist-name">{{ artistInfo.name }}</h1>
          <p class="listen-month">447,854 monthly listeners</p>
        </div>
      </div>
    </div>
    <div class="section-content">
      <a-row>
        <a-col :span="24">
          <div class="group-button">
            <a-button class="btn-play" @click="playPlaylist"><a-icon type="caret-right"/></a-button>
            <a-button class="btn-following">Following</a-button>
          </div>
        </a-col>
      </a-row>
      <a-row v-show="popularMusic.length">
        <a-col :xs="{ span: 24 }" :sm="{ span: 24 }" :md="{ span: 24 }" :lg="{ span: 24 }">
          <a-row>
            <a-col :span="24">
              <p class="list-title">Popular</p>
            </a-col>
          </a-row>
          <a-row>
            <a-col class="col-data" :xs="{ span: 24 }" :sm="{ span: 24 }" :md="{ span: 24 }" :lg="{ span: 24 }">
              <a-table
                :columns="columns"
                :data-source="popularMusic"
                :pagination="false"
                :customRow="handleClickRow"
                class="popular-music"
              >
                <span slot="play" style="color: #808080"><a-icon type="caret-right"/></span>
                <span slot="name" slot-scope="name" style="color: #808080">{{ name }}</span>
                <span slot="date" slot-scope="date" style="color: #808080">{{ date }}</span>
                <span slot="duration" slot-scope="duration" style="color: #808080">{{ duration }}</span>
              </a-table>
            </a-col>
          </a-row>
        </a-col>
      </a-row>
      <a-row v-show="allMusic.length">
        <a-col :span="24">
          <p class="list-title">All tracks</p>
        </a-col>
        <a-col class="col-data" :xs="{ span: 24 }" :sm="{ span: 24 }" :md="{ span: 24 }" :lg="{ span: 24 }">
          <a-table
            :columns="columns"
            :data-source="allMusic"
            :pagination="false"
            :customRow="handleClickRow"
            class="all-music"
          >
            <span slot="play" style="color: #808080"><a-icon type="caret-right"/></span>
            <span slot="name" slot-scope="name" style="color: #808080">{{ name }}</span>
            <span slot="date" slot-scope="date" style="color: #808080">{{ date }}</span>
            <span slot="duration" slot-scope="duration" style="color: #808080">{{ duration }}</span>
          </a-table>
        </a-col>
      </a-row>
      <a-row :gutter="24" class="album-section" v-if="artistInfo.album_count">
        <a-col :span="24">
          <p class="list-title">Albums</p>
        </a-col>
        <a-col
          class="gutter-row"
          :xs="{ span: 12 }"
          :sm="{ span: 8 }"
          :md="{ span: 6 }"
          :lg="{ span: 6 }"
          :xxl="{ span: 4 }"
          v-for="item in albums"
          :key="item.id"
        >
          <div class="category">
            <div class="background">
              <div class="wrap-image square">
                <img :src="item.url" />
                <span class="btn-play">
                  <a-icon type="caret-right" />
                </span>
              </div>
              <h3 class="title">{{ item.title }}</h3>
              <div class="description" v-if="!isMobileGlobal()">{{ item.content }}</div>
            </div>
          </div>
        </a-col>
      </a-row>
      <a-row class="about">
        <a-col :span="24" class="list-title">About</a-col>
        <a-col :span="24" class="des">{{ artistInfo.description || artistInfo.content }}</a-col>
        <a-col :span="24">
          <p class="follower">{{ follower }}</p>
          <p>Followers</p>
        </a-col>
      </a-row>
    </div>
  </div>
</template>

<script>
import service from "../../service.js";

const columns = [
  {
    title: "Buy",
    dataIndex: "play",
    scopedSlots: { customRender: "play" }
  },
  {
    title: "Name",
    dataIndex: "name",
    scopedSlots: { customRender: "name" }
  },
  // {
  //   title: "Artist",
  //   dataIndex: "artist",
  //   scopedSlots: { customRender: "artist" }
  // },
  {
    title: "Date",
    dataIndex: "date",
    scopedSlots: { customRender: "date" }
  },
  {
    title: "Duration",
    dataIndex: "duration",
    scopedSlots: { customRender: "duration" }
  }
];

export default {
  data() {
    return {
      columns: columns,
      follower: 0,
      following: 0,
      totalView: 0,
      popularMusic: [],
      allMusic: [],
      artistInfo: {}
    };
  },
  methods: {
    formatCreateDate(time) {
      let result = time
        .split(" ")[0]
        .split("-")
        .join("/");
      return result;
    },
    async callServiceArtist() {
      const route = this.$route;
      const artistId = route && route.params && route.params.id ? route.params.id : 0;
      const token = localStorage.getItem("Authorization");
      const params = {
        page: 1,
        number_per_page: 30,
        artist_id: artistId
      };
      if (token) {
        params.token = token;
      }

      let res = await service.get("/artist/home-artist", { params });

      if (!res || !res.data || res.data.code !== 200 || !res.data.data) return;

      let dataArtist = res.data.data;
      let popularMusic = dataArtist.topSong;
      let allMusic = dataArtist.allSong;

      this.follower = dataArtist.follower;
      this.following = dataArtist.following;
      this.totalView = dataArtist.totalViews;
      this.popularMusic = this.mapDataMusic(popularMusic);
      this.allMusic = this.mapDataMusic(allMusic);
      this.artistInfo = this.allMusic[0] && this.allMusic[0].musicArtist ? this.allMusic[0].musicArtist : {};
    },
    mapDataMusic(arrData) {
      let result = [...arrData];

      arrData.forEach((item, ind) => {
        result[ind].date = this.formatCreateDate(item.created_at);
        result[ind].key = ind;
        result[ind].duration = "00:00";

        let sound = new Howl({
          src: [item.song_file],
          html5: true
        });
        sound.on("load", () => {
          result[ind].duration = this.formatterTimeGl(sound.duration());
        });
      });
      return result;
    },
    handleClickRow(record) {
      return {
        on: {
          click: (event) => {
            if (!record.song_file) return;

            let music = {
              id: record.id,
              url: record.song_file,
              title: record.name,
              artist: record.userNameArtist,
              photo: record.img_thumb || record.img_banner
            };
            this.playMusic(music);
            this.getCurrentPlaylist(event.path);
          }
        }
      };
    },
    getCurrentPlaylist(pathEvent) {
      let isPopularPlaylist = pathEvent.find(
        (item) => item && item.className && item.className.includes("popular-music")
      );
      let data;

      if (isPopularPlaylist) {
        data = this.popularMusic.map((item) => {
          return {
            id: item.id,
            url: item.song_file,
            title: item.name,
            artist: item.userNameArtist,
            photo: item.img_thumb || item.img_banner
          };
        });
      } else {
        data = this.allMusic.map((item) => {
          return {
            id: item.id,
            url: item.song_file,
            title: item.name,
            artist: item.userNameArtist,
            photo: item.img_thumb || item.img_banner
          };
        });
      }
      this.$store.commit("player/setPlaylist", data);
    },
    playMusic(music) {
      this.$store.dispatch("player/playMusic", music);
    },
    playPlaylist() {
      let music = this.allMusic[0];

      if (!music) return;
      
      music = {
        id: music.id,
        url: music.song_file,
        title: music.name,
        artist: music.userNameArtist,
        photo: music.img_thumb || music.img_banner
      };
      this.playMusic(music);
      this.getCurrentPlaylist([]);
    }
  },
  mounted() {
    this.callServiceArtist();
  }
};
</script>

<style scoped>
.artist-detail-section {
  padding-bottom: 60px;
}
.section-header {
  height: 340px;
  width: 100%;
  overflow: hidden;
  padding-bottom: 24px;
}
.section-header > img {
  object-fit: cover;
}
.section-content >>> .ant-table-thead {
  display: none !important;
}
.section-content {
  margin: 0 32px;
}

.header-artists {
  width: 100%;
  position: absolute;
  bottom: 0;
  margin: 0 32px;
  display: flex;
  align-items: flex-end;
}
.background-opacity {
  width: 100%;
  height: 100%;
  bottom: 0;
  position: absolute;

  background: linear-gradient(2deg, rgb(0 0 0 / 85%), rgb(0 0 0 / 33%));
}
.group-info {
  width: 100%;
  height: auto;
  text-align: left;
}
.group-info .artist-name {
  padding: 0.08em 0px;
  font-size: 96px;
  line-height: 96px;
  font-weight: 900;
  margin: 0;
}
.group-info .listen-month {
  font-size: 16px;
  margin-top: 4px;
}
.group-button {
  display: flex;
  align-items: center;
  padding: 24px 0;
}
.group-button .btn-play {
  background-color: #1db954;
  border: none !important;
  color: #fff !important;
  border-radius: 50%;
  padding: 0;
  width: 64px;
  height: 64px;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  margin-right: 32px;
}
.group-button .btn-play:hover {
  transition: all 0.3s ease;
  transform: scale(1.1);
}
.group-button .btn-play i {
  font-size: 40px;
  margin-left: 4px;
  margin-top: 8px;
}
.group-button .btn-following {
  font-size: 12px;
  line-height: 16px;
  font-weight: 700;
  text-transform: uppercase;
  text-align: center;
  color: #fff;
  background-color: transparent;
  padding: 7px 15px;
  border: 1px solid hsla(0, 0%, 100%, 0.3);
  border-radius: 4px;
}
.group-button .btn-more {
  width: 35px;
  height: 35px;
  border-radius: 50%;
  background-color: transparent;
  color: #fff;
  text-align: center;
  font-size: 1.3rem;
}
.list-title {
  font-size: 24px;
  font-weight: 700;
  line-height: 28px;
  text-align: left;
  padding: 40px 0 22px;
  margin: 0;
}
.col-data {
  padding: 0 12px;
}
.card-release {
  height: 100px;
  width: 100%;
  display: flex;
}
.card-release_img {
  width: 100px;
  height: 100px;
}
.card-release_img img {
  width: 100px;
  height: 100px;
  object-fit: cover;
}
.card-release_title {
  margin-left: 25px;
  margin-top: 25px;
  text-align: left;
}
.card-release:hover {
  background-color: #000;
}
.album-section .title,
.album-section .description {
  text-align: left;
}
.about * {
  text-align: left;
}
.about .des {
  font-size: 16px;
  font-weight: 400;
  line-height: 24px;
}
.about .follower {
  font-size: 32px;
  font-weight: 700;
  line-height: 36px;
  letter-spacing: -0.04em;
  margin-top: 60px;
  margin-bottom: 0;
}
/* Mobile Style */
.mobile .artist-avatar {
  width: 150px;
  height: 150px;
  border-radius: 50%;
  object-fit: cover;
  filter: drop-shadow(rgba(0, 0, 0, 0.3) 0px 0px 1px) drop-shadow(rgba(0, 0, 0, 0.3) 0px 0px 10px);
}
.mobile .header-artists {
  height: 100%;
  top: 0;
  margin: 0;
  display: block;
}
.mobile .group-info {
  padding-top: 62px;
  display: flex;
  flex-direction: column;
  align-items: center;
}
.mobile .section-header > img {
  object-fit: cover;
  height: 140%;
  filter: brightness(0.5) blur(10px);
}
.mobile .section-header::after {
  content: "";
  position: absolute;
  left: 0;
  bottom: -6px;
  width: 100%;
  height: 120px;
  background: linear-gradient(0deg, #121212ff 0%, #12121200 100%);
}
.mobile .group-info .artist-name {
  font-size: 32px;
  font-weight: 600;
  letter-spacing: -0.04em;
  line-height: 36px;
  margin: 0;
}
.mobile .group-info .listen-month {
  font-size: 12px;
}
.mobile .section-content {
  margin: 0 16px;
}
.mobile .col-data {
  padding: 0;
}
.mobile .all-music >>> .ant-table-tbody > tr > td, 
.mobile .popular-music >>> .ant-table-tbody > tr > td {
  padding: 10px 10px !important;
}
.mobile .all-music >>> .ant-table-tbody > tr > td span, 
.mobile .popular-music >>> .ant-table-tbody > tr > td span {
  display: -webkit-box;
  -webkit-box-orient: vertical;
  -webkit-line-clamp: 2;
  overflow: hidden;
}
</style>
